import { create } from "zustand";
import { CodeEditorState } from "@/types";
import { DEFAULT_THEME } from "@/constants/editor/themes";
import { DEFAULT_LANGUAGE } from "@/constants/editor/languages";
import { persist, createJSONStorage } from "zustand/middleware";
import { DEFAULT_FONT_SIZE } from "@/constants/editor/options";

export const useCodeEditorStore = create<CodeEditorState>()(
  persist(
    (set) => ({
      language: DEFAULT_LANGUAGE,
      theme: DEFAULT_THEME,
      fontSize: DEFAULT_FONT_SIZE,

      setLanguage: (language: string) => set({ language }),
      setTheme: (theme: string) => set({ theme }),
      setFontSize: (fontSize: number) => set({ fontSize }),
    }),
    {
      name: "code-editor-storage",
      storage: createJSONStorage(() => localStorage),
    }
  )
);
